diff --git a/mllib/random_seed.ml b/mllib/random_seed.ml
new file mode 100644
index 0000000..84236cd
--- /dev/null
+++ b/mllib/random_seed.ml
@@ -0,0 +1,96 @@
+(* virt-sysprep
+ * Copyright (C) 2012-2014 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+(* It's important that we write a random seed if we possibly can.
+ * Unfortunately some installers (hello, Debian) don't include the file
+ * in the basic guest, so we have to work out where to create it.
+ *)
+let rec set_random_seed (g : Guestfs.guestfs) root =
+  let typ = g#inspect_get_type root in
+  let created = ref false in
+
+  if typ = "linux" then (
+    let files = [
+      "/var/lib/random-seed";         (* Fedora *)
+      "/var/lib/urandom/random-seed"; (* Debian *)
+      "/var/lib/misc/random-seed";    (* SuSE *)
+    ] in
+    List.iter (
+      fun file ->
+        if g#is_file file then (
+          make_random_seed_file g file;
+          created := true
+        )
+    ) files;
+  );
+
+  if not !created then (
+    (* Backup plan: Try to create a new file. *)
+
+    let distro = g#inspect_get_distro root in
+    let file =
+      match typ, distro with
+      | "linux", ("fedora"|"rhel"|"centos"|"scientificlinux"|"redhat-based") ->
+        Some "/var/lib/random-seed"
+      | "linux", ("debian"|"ubuntu") ->
+        Some "/var/lib/urandom/random-seed"
+      | "linux", ("opensuse"|"sles"|"suse-based") ->
+        Some "/var/lib/misc/random-seed"
+      | _ ->
+        None in
+    match file with
+    | Some file ->
+      make_random_seed_file g file;
+      created := true
+    | None -> ()
+  );
+
+  !created
+
+and make_random_seed_file g file =
+  let file_exists = g#is_file file in
+  let n =
+    if file_exists then (
+      let n = Int64.to_int (g#filesize file) in
+
+      (* This file is usually 512 bytes in size.  However during
+       * guest creation of some guests it can be just 8 bytes long.
+       * Cap the file size to [512, 8192] bytes.
+       *)
+      min (max n 512) 8192
+    )
+    else
+      (* Default to 512 bytes of randomness. *)
+      512 in
+
+  (* Get n bytes of randomness from the host. *)
+  let entropy = Urandom.urandom_bytes n in
+
+  if file_exists then (
+    (* Truncate the original file and append, in order to
+     * preserve original permissions.
+     *)
+    g#truncate file;
+    g#write_append file entropy
+  )
+  else (
+    (* Create a new file, set the permissions restrictively. *)
+    g#write file entropy;
+    g#chown 0 0 file;
+    g#chmod 0o600 file
+  )
diff --git a/mllib/random_seed.mli b/mllib/random_seed.mli
new file mode 100644
index 0000000..b5261f2
--- /dev/null
+++ b/mllib/random_seed.mli
@@ -0,0 +1,21 @@
+(* virt-sysprep
+ * Copyright (C) 2012-2014 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+val set_random_seed : Guestfs.guestfs -> string -> bool
+(** Set the random seed in the guest.  Returns true if it was able to
+    do set it, false if not. *)
diff --git a/mllib/tTY.ml b/mllib/tTY.ml
new file mode 100644
index 0000000..80f0e1e
--- /dev/null
+++ b/mllib/tTY.ml
@@ -0,0 +1,19 @@
+(* virt-resize
+ * Copyright (C) 2013 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+external isatty_stdout : unit -> bool = "virt_resize_isatty_stdout" "noalloc"
diff --git a/mllib/tTY.mli b/mllib/tTY.mli
new file mode 100644
index 0000000..69441f1
--- /dev/null
+++ b/mllib/tTY.mli
@@ -0,0 +1,23 @@
+(* virt-resize
+ * Copyright (C) 2013 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+(** TTY utilities. *)
+
+val isatty_stdout : unit -> bool
+(** RHEL 5-era ocaml didn't have Unix.isatty.  This is not needed in
+    recent OCaml. *)
diff --git a/mllib/tty-c.c b/mllib/tty-c.c
new file mode 100644
index 0000000..64fa884
--- /dev/null
+++ b/mllib/tty-c.c
@@ -0,0 +1,38 @@
+/* virt-resize - interface to isatty
+ * Copyright (C) 2013 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+#include <config.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+#include <caml/memory.h>
+#include <caml/mlvalues.h>
+
+/* RHEL 5-era ocaml didn't have Unix.isatty.
+ *
+ * Note this function is marked as "noalloc" so it must not call any
+ * OCaml allocation functions:
+ * http://camltastic.blogspot.co.uk/2008/08/tip-calling-c-functions-directly-with.html
+ */
+value
+virt_resize_isatty_stdout (value unitv)
+{
+  return isatty (1) ? Val_true : Val_false;
+}
diff --git a/mllib/urandom.ml b/mllib/urandom.ml
new file mode 100644
index 0000000..9b613e8
--- /dev/null
+++ b/mllib/urandom.ml
@@ -0,0 +1,69 @@
+(* Read /dev/urandom.
+ * Copyright (C) 2013 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+(* Read and return N bytes (only) from /dev/urandom.
+ *
+ * As pointed out by Edwin Török, previous versions of this had a big
+ * problem.  They used the OCaml buffered I/O library which would read
+ * a lot more data than requested.  This version uses unbuffered I/O
+ * from the Unix module.
+ *)
+
+open Unix
+
+let open_urandom_fd () = openfile "/dev/urandom" [O_RDONLY] 0
+
+let read_byte fd =
+  let s = String.make 1 ' ' in
+  fun () ->
+    if read fd s 0 1 = 0 then (
+      close fd;
+      raise End_of_file
+    );
+    Char.code s.[0]
+
+let urandom_bytes n =
+  assert (n > 0);
+  let ret = String.make n ' ' in
+  let fd = open_urandom_fd () in
+  for i = 0 to n-1 do
+    ret.[i] <- Char.chr (read_byte fd ())
+  done;
+  close fd;
+  ret
+
+(* Return a random number uniformly distributed in [0, upper_bound)
+ * avoiding modulo bias.
+ *)
+let rec uniform_random read upper_bound =
+  let c = read () in
+  if c >= 256 mod upper_bound then c mod upper_bound
+  else uniform_random read upper_bound
+
+let urandom_uniform n chars =
+  assert (n > 0);
+  let nr_chars = String.length chars in
+  assert (nr_chars > 0);
+
+  let ret = String.make n ' ' in
+  let fd = open_urandom_fd () in
+  for i = 0 to n-1 do
+    ret.[i] <- chars.[uniform_random (read_byte fd) nr_chars]
+  done;
+  close fd;
+  ret
diff --git a/mllib/urandom.mli b/mllib/urandom.mli
new file mode 100644
index 0000000..ffc77dd
--- /dev/null
+++ b/mllib/urandom.mli
@@ -0,0 +1,26 @@
+(* Read /dev/urandom.
+ * Copyright (C) 2013 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+(** Read and return N bytes (only) from /dev/urandom. *)
+
+val urandom_bytes : int -> string
+(** Read N bytes from /dev/urandom and return it as a binary string. *)
+
+val urandom_uniform : int -> string -> string
+(** [urandom_uniform n chars] returns [n] bytes, uniformly
+    distributed from the sets of characters [chars]. *)
diff --git a/po/POTFILES b/po/POTFILES
index 7b28d38..f539a0f 100644
--- a/po/POTFILES
+++ b/po/POTFILES
@@ -208,6 +208,9 @@ gobject/src/tristate.c
 inspector/virt-inspector.c
 java/com_redhat_et_libguestfs_GuestFS.c
 lua/lua-guestfs.c
+mllib/crypt-c.c
+mllib/progress-c.c
+mllib/tty-c.c
 ocaml/guestfs-c-actions.c
 ocaml/guestfs-c.c
 perl/Guestfs.c
@@ -219,8 +222,6 @@ python/guestfs-py-byhand.c
 python/guestfs-py.c
 rescue/test-virt-rescue.pl
 rescue/virt-rescue.c
-resize/progress-c.c
-resize/tty-c.c
 ruby/ext/guestfs/_guestfs.c
 src/actions-0.c
 src/actions-1.c
diff --git a/po/POTFILES-ml b/po/POTFILES-ml
index d23b29d..c375dd6 100644
--- a/po/POTFILES-ml
+++ b/po/POTFILES-ml
@@ -1,11 +1,5 @@
-resize/common_gettext.ml
-resize/common_utils.ml
-resize/common_utils_tests.ml
-resize/progress.ml
 resize/resize.ml
-resize/tTY.ml
 sparsify/sparsify.ml
-sysprep/firstboot.ml
 sysprep/main.ml
 sysprep/sysprep_operation.ml
 sysprep/sysprep_operation_abrt_data.ml
@@ -17,6 +11,7 @@ sysprep/sysprep_operation_cron_spool.ml
 sysprep/sysprep_operation_dhcp_client_state.ml
 sysprep/sysprep_operation_dhcp_server_state.ml
 sysprep/sysprep_operation_dovecot_data.ml
+sysprep/sysprep_operation_firewall_rules.ml
 sysprep/sysprep_operation_firstboot.ml
 sysprep/sysprep_operation_flag_reconfiguration.ml
 sysprep/sysprep_operation_hostname.ml
@@ -30,6 +25,7 @@ sysprep/sysprep_operation_net_hwaddr.ml
 sysprep/sysprep_operation_pacct_log.ml
 sysprep/sysprep_operation_package_manager_cache.ml
 sysprep/sysprep_operation_pam_data.ml
+sysprep/sysprep_operation_password.ml
 sysprep/sysprep_operation_puppet_data_log.ml
 sysprep/sysprep_operation_random_seed.ml
 sysprep/sysprep_operation_rhn_systemid.ml
@@ -40,6 +36,7 @@ sysprep/sysprep_operation_smolt_uuid.ml
 sysprep/sysprep_operation_ssh_hostkeys.ml
 sysprep/sysprep_operation_ssh_userdir.ml
 sysprep/sysprep_operation_sssd_db_log.ml
+sysprep/sysprep_operation_tmp_files.ml
 sysprep/sysprep_operation_udev_persistent_net.ml
 sysprep/sysprep_operation_user_account.ml
 sysprep/sysprep_operation_utmp.ml
diff --git a/resize/Makefile.am b/resize/Makefile.am
index 2431e34..d03a11c 100644
--- a/resize/Makefile.am
+++ b/resize/Makefile.am
@@ -26,28 +26,19 @@ CLEANFILES = *~ *.cmi *.cmo *.cmx *.cmxa *.o virt-resize test.img
 
 # Alphabetical order.
 SOURCES = \
-	common_gettext.ml \
-	common_utils.ml \
-	common_utils_tests.ml \
-	progress-c.c \
-	progress.mli \
-	progress.ml \
-	resize.ml \
-	tty-c.c \
-	tTY.mli \
-	tTY.ml
+	resize.ml
 
 if HAVE_OCAML
 
 # Note this list must be in dependency order.
 OBJECTS = \
+	$(top_builddir)/mllib/tty-c.o \
+	$(top_builddir)/mllib/tTY.cmx \
 	$(top_builddir)/fish/guestfish-progress.o \
-	tty-c.o \
-	progress-c.o \
-	common_gettext.cmx \
-	common_utils.cmx \
-	tTY.cmx \
-	progress.cmx \
+	$(top_builddir)/mllib/progress-c.o \
+	$(top_builddir)/mllib/progress.cmx \
+	$(top_builddir)/mllib/common_gettext.cmx \
+	$(top_builddir)/mllib/common_utils.cmx \
 	resize.cmx
 
 bin_SCRIPTS = virt-resize
@@ -55,7 +46,11 @@ bin_SCRIPTS = virt-resize
 # -I $(top_builddir)/src/.libs is a hack which forces corresponding -L
 # option to be passed to gcc, so we don't try linking against an
 # installed copy of libguestfs.
-OCAMLPACKAGES = -package str,unix -I $(top_builddir)/src/.libs -I ../ocaml
+OCAMLPACKAGES = \
+	-package str,unix \
+	-I $(top_builddir)/src/.libs \
+	-I $(top_builddir)/ocaml \
+	-I $(top_builddir)/mllib
 if HAVE_OCAML_PKG_GETTEXT
 OCAMLPACKAGES += -package gettext-stub
 endif
@@ -105,15 +100,9 @@ CLEANFILES += stamp-virt-resize.pod
 
 # Tests.
 
-check_SCRIPTS = common_utils_tests
-
-common_utils_tests: common_gettext.cmx common_utils.cmx common_utils_tests.cmx
-	$(OCAMLFIND) ocamlopt $(OCAMLOPTFLAGS) \
-	  mlguestfs.cmxa -linkpkg $^ -cclib -lncurses -o $@
-
 TESTS_ENVIRONMENT = $(top_builddir)/run --test
 
-TESTS = common_utils_tests
+TESTS =
 if ENABLE_APPLIANCE
 TESTS += test-virt-resize.sh
 endif
@@ -126,7 +115,7 @@ depend: .depend
 
 .depend: $(wildcard $(abs_srcdir)/*.mli) $(wildcard $(abs_srcdir)/*.ml)
 	rm -f $@ $@-t
-	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) $^ | \
+	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) -I $(top_srcdir)/mllib $^ | \
 	  $(SED) 's/ *$$//' | \
 	  $(SED) -e :a -e '/ *\\$$/N; s/ *\\\n */ /; ta' | \
 	  $(SED) -e 's,$(abs_srcdir)/,$(builddir)/,g' | \
diff --git a/resize/resize.ml b/resize/resize.ml
index 580ff8f..f9053c1 100644
--- a/resize/resize.ml
+++ b/resize/resize.ml
@@ -29,6 +29,7 @@ let min_extra_partition = 10L *^ 1024L *^ 1024L
 
 (* Command line argument parsing. *)
 let prog = Filename.basename Sys.executable_name
+let error fs = error ~prog fs
 
 type align_first_t = [ `Never | `Always | `Auto ]
 
@@ -628,7 +629,7 @@ let () =
 
     (* Parse the size field. *)
     let oldsize = p.p_part.G.part_size in
-    let newsize = parse_size oldsize sizefield in
+    let newsize = parse_resize ~prog oldsize sizefield in
 
     if newsize <= 0L then
       error (f_"%s: new partition size is zero or negative") dev;
diff --git a/sparsify/Makefile.am b/sparsify/Makefile.am
index 3bc1d0e..2df0dbf 100644
--- a/sparsify/Makefile.am
+++ b/sparsify/Makefile.am
@@ -33,12 +33,12 @@ if HAVE_OCAML
 # Note this list must be in dependency order.
 OBJECTS = \
 	$(top_builddir)/fish/guestfish-progress.o \
-	$(top_builddir)/resize/tty-c.o \
-	$(top_builddir)/resize/progress-c.o \
-	$(top_builddir)/resize/common_gettext.cmx \
-	$(top_builddir)/resize/common_utils.cmx \
-	$(top_builddir)/resize/tTY.cmx \
-	$(top_builddir)/resize/progress.cmx \
+	$(top_builddir)/mllib/tty-c.o \
+	$(top_builddir)/mllib/progress-c.o \
+	$(top_builddir)/mllib/common_gettext.cmx \
+	$(top_builddir)/mllib/common_utils.cmx \
+	$(top_builddir)/mllib/tTY.cmx \
+	$(top_builddir)/mllib/progress.cmx \
 	sparsify.cmx
 
 bin_SCRIPTS = virt-sparsify
@@ -46,7 +46,11 @@ bin_SCRIPTS = virt-sparsify
 # -I $(top_builddir)/src/.libs is a hack which forces corresponding -L
 # option to be passed to gcc, so we don't try linking against an
 # installed copy of libguestfs.
-OCAMLPACKAGES = -package str,unix -I $(top_builddir)/src/.libs -I $(top_builddir)/ocaml -I $(top_builddir)/resize
+OCAMLPACKAGES = \
+	-package str,unix \
+	-I $(top_builddir)/src/.libs \
+	-I $(top_builddir)/ocaml \
+	-I $(top_builddir)/mllib
 if HAVE_OCAML_PKG_GETTEXT
 OCAMLPACKAGES += -package gettext-stub
 endif
@@ -110,7 +114,7 @@ depend: .depend
 
 .depend: $(wildcard $(abs_srcdir)/*.mli) $(wildcard $(abs_srcdir)/*.ml)
 	rm -f $@ $@-t
-	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) -I $(top_srcdir)/resize $^ | \
+	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) -I $(top_srcdir)/mllib $^ | \
 	  $(SED) 's/ *$$//' | \
 	  $(SED) -e :a -e '/ *\\$$/N; s/ *\\\n */ /; ta' | \
 	  $(SED) -e 's,$(abs_srcdir)/,$(builddir)/,g' | \
diff --git a/sparsify/sparsify.ml b/sparsify/sparsify.ml
index 6ea34ee..a32ef83 100644
--- a/sparsify/sparsify.ml
+++ b/sparsify/sparsify.ml
@@ -30,6 +30,7 @@ let () = Random.self_init ()
 
 (* Command line argument parsing. *)
 let prog = Filename.basename Sys.executable_name
+let error fs = error ~prog fs
 
 let indisk, outdisk, compress, convert, debug_gc,
   format, ignores, machine_readable,
diff --git a/sysprep/Makefile.am b/sysprep/Makefile.am
index 61e93be..8bea9fc 100644
--- a/sysprep/Makefile.am
+++ b/sysprep/Makefile.am
@@ -1,5 +1,5 @@
 # libguestfs virt-sysprep tool
-# Copyright (C) 2012 Red Hat Inc.
+# Copyright (C) 2012-2014 Red Hat Inc.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -40,6 +40,7 @@ operations = \
 	dhcp_server_state \
 	dovecot_data \
 	flag_reconfiguration \
+	firewall_rules \
 	firstboot \
 	hostname \
 	kerberos_data \
@@ -52,6 +53,7 @@ operations = \
 	pacct_log \
 	package_manager_cache \
 	pam_data \
+	password \
 	puppet_data_log \
 	random_seed \
 	rhn_systemid \
@@ -62,14 +64,13 @@ operations = \
 	ssh_hostkeys \
 	ssh_userdir \
 	sssd_db_log \
+	tmp_files \
 	udev_persistent_net \
 	user_account \
 	utmp yum_uuid
 
 # Alphabetical order.
 SOURCES = \
-	firstboot.ml \
-	firstboot.mli \
 	main.ml \
 	sysprep_operation.ml \
 	sysprep_operation.mli \
@@ -79,9 +80,16 @@ if HAVE_OCAML
 
 # Note this list must be in dependency order.
 OBJECTS = \
-	$(top_builddir)/resize/common_gettext.cmx \
-	$(top_builddir)/resize/common_utils.cmx \
-	firstboot.cmx \
+	$(top_builddir)/mllib/common_gettext.cmx \
+	$(top_builddir)/mllib/common_utils.cmx \
+	$(top_builddir)/mllib/crypt-c.o \
+	$(top_builddir)/mllib/crypt.cmx \
+	$(top_builddir)/mllib/urandom.cmx \
+	$(top_builddir)/mllib/password.cmx \
+	$(top_builddir)/mllib/random_seed.cmx \
+	$(top_builddir)/mllib/hostname.cmx \
+	$(top_builddir)/mllib/firstboot.cmx \
+	$(top_builddir)/mllib/config.cmx \
 	sysprep_operation.cmx \
 	$(patsubst %,sysprep_operation_%.cmx,$(operations)) \
 	main.cmx
@@ -91,7 +99,11 @@ bin_SCRIPTS = virt-sysprep
 # -I $(top_builddir)/src/.libs is a hack which forces corresponding -L
 # option to be passed to gcc, so we don't try linking against an
 # installed copy of libguestfs.
-OCAMLPACKAGES = -package str,unix -I $(top_builddir)/src/.libs -I $(top_builddir)/ocaml -I $(top_builddir)/resize
+OCAMLPACKAGES = \
+	-package str,unix \
+	-I $(top_builddir)/src/.libs \
+	-I $(top_builddir)/ocaml \
+	-I $(top_builddir)/mllib
 if HAVE_OCAML_PKG_GETTEXT
 OCAMLPACKAGES += -package gettext-stub
 endif
@@ -99,10 +111,15 @@ endif
 OCAMLCFLAGS = -g -warn-error CDEFLMPSUVYZX $(OCAMLPACKAGES)
 OCAMLOPTFLAGS = $(OCAMLCFLAGS)
 
+OCAMLCLIBS  = \
+	$(LIBXML2_LIBS) -lncurses -lcrypt \
+	-L../src/.libs -lutils \
+	-L../gnulib/lib/.libs -lgnu
+
 virt-sysprep: $(OBJECTS)
 	$(OCAMLFIND) ocamlopt $(OCAMLOPTFLAGS) \
 	  mlguestfs.cmxa -linkpkg $^ \
-	  -cclib -lncurses \
+	  -cclib '$(OCAMLCLIBS)' \
 	  $(OCAML_GCOV_LDFLAGS) \
 	  -o $@
 
@@ -113,6 +130,19 @@ virt-sysprep: $(OBJECTS)
 .ml.cmx:
 	$(OCAMLFIND) ocamlopt $(OCAMLOPTFLAGS) -c $< -o $@
 
+# automake will decide we don't need C support in this file.  Really
+# we do, so we have to provide it ourselves.
+
+DEFAULT_INCLUDES = \
+	-I. \
+	-I$(top_builddir) \
+	-I$(shell $(OCAMLC) -where) \
+	-I$(top_srcdir)/src \
+	-I$(top_srcdir)/fish
+
+.c.o:
+	$(CC) $(CFLAGS) $(PROF_CFLAGS) $(DEFAULT_INCLUDES) -c $< -o $@
+
 # Manual pages and HTML files for the website.
 man_MANS = virt-sysprep.1
 noinst_DATA = $(top_builddir)/html/virt-sysprep.1.html
@@ -144,6 +174,7 @@ sysprep-operations.pod: virt-sysprep
 TESTS_ENVIRONMENT = \
 	abs_builddir=$(abs_builddir) \
 	abs_srcdir=$(abs_srcdir) \
+	PATH=$(abs_top_builddir)/fuse:$(PATH) \
 	$(top_builddir)/run --test
 
 if ENABLE_APPLIANCE
@@ -165,7 +196,7 @@ depend: .depend
 
 .depend: $(wildcard $(abs_srcdir)/*.mli) $(wildcard $(abs_srcdir)/*.ml)
 	rm -f $@ $@-t
-	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) -I $(top_srcdir)/resize $^ | \
+	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) -I $(top_srcdir)/mllib $^ | \
 	  $(SED) 's/ *$$//' | \
 	  $(SED) -e :a -e '/ *\\$$/N; s/ *\\\n */ /; ta' | \
 	  $(SED) -e 's,$(abs_srcdir)/,$(builddir)/,g' | \
@@ -176,8 +207,6 @@ depend: .depend
 
 endif
 
-.PHONY: depend docs
+DISTCLEANFILES = .depend
 
-# Parallel builds don't obey dependencies for some reason we
-# don't understand.
-.NOTPARALLEL:
+.PHONY: depend docs
diff --git a/sysprep/main.ml b/sysprep/main.ml
index 212538f..6e7a3c0 100644
--- a/sysprep/main.ml
+++ b/sysprep/main.ml
@@ -1,5 +1,5 @@
 (* virt-sysprep
- * Copyright (C) 2012 Red Hat Inc.
+ * Copyright (C) 2012-2014 Red Hat Inc.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -31,7 +31,7 @@ let () = Sysprep_operation.bake ()
 (* Command line argument parsing. *)
 let prog = Filename.basename Sys.executable_name
 
-let debug_gc, operations, g, selinux_relabel, quiet =
+let debug_gc, operations, g, selinux_relabel, quiet, mount_opts =
   let debug_gc = ref false in
   let domain = ref None in
   let dryrun = ref false in
@@ -43,12 +43,10 @@ let debug_gc, operations, g, selinux_relabel, quiet =
   let selinux_relabel = ref `Auto in
   let trace = ref false in
   let verbose = ref false in
+  let mount_opts = ref "" in
 
   let display_version () =
-    let g = new G.guestfs () in
-    let version = g#version () in
-    printf "virt-sysprep %Ld.%Ld.%Ld%s\n"
-      version.G.major version.G.minor version.G.release version.G.extra;
+    printf "virt-sysprep %s\n" Config.package_version;
     exit 0
   and add_file file =
     let format = match !format with "auto" -> None | fmt -> Some fmt in
@@ -74,7 +72,7 @@ let debug_gc, operations, g, selinux_relabel, quiet =
       eprintf (f_"%s: you cannot pass an empty argument to --enable\n") prog;
       exit 1
     );
-    let ops = string_split "," ops in
+    let ops = string_nsplit "," ops in
     let opset = List.fold_left (
       fun opset op_name ->
         try Sysprep_operation.add_to_set op_name opset
@@ -109,6 +107,8 @@ let debug_gc, operations, g, selinux_relabel, quiet =
     "--enable",  Arg.String set_enable,     s_"operations" ^ " " ^ s_"Enable specific operations";
     "--format",  Arg.Set_string format,     s_"format" ^ " " ^ s_"Set format (default: auto)";
     "--list-operations", Arg.Unit list_operations, " " ^ s_"List supported operations";
+    "--long-options", Arg.Unit display_long_options, " " ^ s_"List long options";
+    "--mount-options", Arg.Set_string mount_opts, s_"opts" ^ " " ^ s_"Set mount options (eg /:noatime;/var:rw,noatime)";
     "-q",        Arg.Set quiet,             " " ^ s_"Don't print log messages";
     "--quiet",   Arg.Set quiet,             " " ^ s_"Don't print log messages";
     "--selinux-relabel", Arg.Unit force_selinux_relabel, " " ^ s_"Force SELinux relabel";
@@ -123,6 +123,7 @@ let debug_gc, operations, g, selinux_relabel, quiet =
   let args =
     List.sort (fun (a,_,_) (b,_,_) -> compare_command_line_args a b) args in
   let argspec = Arg.align args in
+  long_options := argspec;
   let anon_fun _ = raise (Arg.Bad (s_"extra parameter on the command line")) in
   let usage_msg =
     sprintf (f_"\
@@ -174,6 +175,15 @@ read the man page virt-sysprep(1).
   let trace = !trace in
   let verbose = !verbose in
 
+  (* Parse the mount options string into a function that maps the
+   * mountpoint to the mount options.
+   *)
+  let mount_opts = !mount_opts in
+  let mount_opts =
+    List.map (string_split ":") (string_nsplit ";" mount_opts) in
+  let mount_opts mp =
+    try List.assoc mp mount_opts with Not_found -> "" in
+
   if not quiet then
     printf (f_"Examining the guest ...\n%!");
 
@@ -184,7 +194,7 @@ read the man page virt-sysprep(1).
   add g dryrun;
   g#launch ();
 
-  debug_gc, operations, g, selinux_relabel, quiet
+  debug_gc, operations, g, selinux_relabel, quiet, mount_opts
 
 let do_sysprep () =
   (* Inspection. *)
@@ -203,7 +213,10 @@ let do_sysprep () =
         let mps = List.sort cmp mps in
         List.iter (
           fun (mp, dev) ->
-            try g#mount dev mp
+            (* Get mount options for this mountpoint. *)
+            let opts = mount_opts mp in
+
+            try g#mount_options opts dev mp;
             with Guestfs.Error msg -> eprintf (f_"%s (ignored)\n") msg
         ) mps;
 
diff --git a/sysprep/sysprep_operation.ml b/sysprep/sysprep_operation.ml
index 2adddba..1fb4f17 100644
--- a/sysprep/sysprep_operation.ml
+++ b/sysprep/sysprep_operation.ml
@@ -22,6 +22,8 @@ open Printf
 
 open Common_gettext.Gettext
 
+let prog = "virt-sysprep"
+
 type flag = [ `Created_files ]
 
 type callback = Guestfs.guestfs -> string -> flag list
@@ -31,10 +33,27 @@ type operation = {
   enabled_by_default : bool;
   heading : string;
   pod_description : string option;
-  extra_args : ((Arg.key * Arg.spec * Arg.doc) * string) list;
+  pod_notes : string option;
+  extra_args : extra_arg list;
   perform_on_filesystems : callback option;
   perform_on_devices : callback option;
 }
+and extra_arg = {
+  extra_argspec : Arg.key * Arg.spec * Arg.doc;
+  extra_pod_argval : string option;
+  extra_pod_description : string;
+}
+
+let defaults = {
+  name = "";
+  enabled_by_default = false;
+  heading = "";
+  pod_description = None;
+  pod_notes = None;
+  extra_args = [];
+  perform_on_filesystems = None;
+  perform_on_devices = None;
+}
 
 let all_operations = ref []
 let enabled_by_default_operations = ref []
@@ -114,6 +133,20 @@ and check op =
         op.name;
       exit 1
     )
+  );
+  (match op.pod_notes with
+  | None -> ()
+  | Some notes ->
+    let n = String.length notes in
+    if n = 0 then (
+      eprintf (f_"virt-sysprep: operation %s has no POD notes\n") op.name;
+      exit 1
+    );
+    if notes.[n-1] = '\n' then (
+      eprintf (f_"virt-sysprep: POD notes for %s must not end with newline\n")
+        op.name;
+      exit 1
+    )
   )
 
 let extra_args () =
@@ -121,7 +154,7 @@ let extra_args () =
 
   List.flatten (
     List.map (fun { extra_args = extra_args } ->
-      List.map fst extra_args
+      List.map (fun { extra_argspec = argspec } -> argspec) extra_args
     ) !all_operations
   )
 
@@ -138,6 +171,14 @@ let dump_pod () =
       (match op.pod_description with
       | None -> ()
       | Some description -> printf "%s\n\n" description
+      );
+      (match op.pod_notes with
+      | None -> ()
+      | Some notes ->
+        printf "=head3 ";
+        printf (f_"Notes on %s") op.name;
+        printf "\n\n";
+        printf "%s\n\n" notes
       )
   ) !all_operations
 
@@ -150,25 +191,28 @@ let dump_pod_options () =
   ) !all_operations in
   let args = List.flatten args in
   let args = List.map (
-    fun (op_name, ((arg_name, spec, _), pod)) ->
-      match spec with
-      | Arg.Unit _
-      | Arg.Bool _
-      | Arg.Set _
-      | Arg.Clear _ ->
-        let heading = sprintf "B<%s>" arg_name in
-        arg_name, (op_name, heading, pod)
-      | Arg.String _
-      | Arg.Set_string _
-      | Arg.Int _
-      | Arg.Set_int _
-      | Arg.Float _
-      | Arg.Set_float _ ->
-        let heading = sprintf "B<%s> %s" arg_name (skip_dashes arg_name) in
-        arg_name, (op_name, heading, pod)
-      | Arg.Tuple _
-      | Arg.Symbol _
-      | Arg.Rest _ -> assert false (* XXX not implemented *)
+    function
+    | (op_name,
+       { extra_argspec = (arg_name,
+                          (Arg.Unit _ | Arg.Bool _ | Arg.Set _ | Arg.Clear _),
+                          _);
+         extra_pod_argval = None;
+         extra_pod_description = pod }) ->
+      let heading = sprintf "B<%s>" arg_name in
+      arg_name, (op_name, heading, pod)
+
+    | (op_name,
+       { extra_argspec = (arg_name,
+                          (Arg.String _ | Arg.Set_string _ | Arg.Int _ |
+                           Arg.Set_int _ | Arg.Float _ | Arg.Set_float _),
+                          _);
+         extra_pod_argval = Some arg_val;
+         extra_pod_description = pod }) ->
+      let heading = sprintf "B<%s> %s" arg_name arg_val in
+      arg_name, (op_name, heading, pod)
+
+    | _ ->
+      failwith "sysprep_operation.ml: argument type not implemented"
   ) args in
 
   let args =
